#include "topo_mapping/tool.h"

namespace topo_mapping
{

	tool::tool()
	{
		
	}
	tool::~tool()
	{

	}
	inline double tool::getNorm(const cv::Point start_p, const cv::Point end_p)
	{
		return (sqrt(pow(start_p.x - end_p.x, 2) + pow(start_p.y - end_p.y, 2)));
	}
	double tool::getNorm(const cv::Point2f start_p, const cv::Point2f end_p)
	{
		return (sqrt(pow(start_p.x - end_p.x, 2) + pow(start_p.y - end_p.y, 2)));
	}
	inline double tool::getNorm(const cv::Point2d start_p, const cv::Point2d end_p)
	{
		return (sqrt(pow(start_p.x - end_p.x, 2) + pow(start_p.y - end_p.y, 2)));
	}
	int tool::getRandI(int low, int high)
	{
		srand((unsigned)time(NULL));  
		return ((rand() % (high - low + 1)) + low);
	}
	double tool::getRand01()
	{
		srand((unsigned)time(NULL));  
		return (rand() / double(RAND_MAX));
	}
	int tool::signum(const int val)
	{
		return (0 < val) - (val < 0);
	}
	double tool::getArea(const cv::Point p1, const cv::Point p2, const cv::Point p3)
	{
		return ((p2.x-p1.x)*(p3.y-p1.y)-(p3.x-p1.x)*(p2.y-p1.y)) / 2.0;
	}
	double tool::ccw(const cv::Point p1, const cv::Point p2, const cv::Point p3)
	{
		cv::Point a = p2 - p1;
		cv::Point b = p3 - p1;

		// 外积Cross  axb
		return (a.x * b.y - a.y * b.x);
	}
	inline double tool::dot(const cv::Point a, const cv::Point b)
	{
		return a.x * b.x + a.y * b.y;
	}
	double tool::computePoint2LineDist(cv::Point p, cv::Point a, cv::Point b)
	{
		if(a == b)
			return getNorm(p, a);
		
		cv::Point v1 = b - a, v2 = p - a, v3 = p - b;
		if(dot(v1, v2) < 0)			// 投影在a的外侧
			return getNorm(v2);	
		else if(dot(v1, v3) > 0)		// 投影在b的外侧
			return getNorm(v3);
		else 
			return fabs(v1.x * v2.y - v1.y * v2.x)/getNorm(v1);
	}







}
